#include <kapplication.h>
#include <kconfig.h>
#include <klocale.h>
#include <kcombobox.h>
#include <khbox.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <klineedit.h>
#include <kglobal.h>
#include "NewWindowDialog.h"

NewWindowDialog::NewWindowDialog(const KSircChannel &channelInfo, QWidget * parent, const char * name)
    : KDialog(parent),
      m_channelInfo(channelInfo)
{
  setCaption(i18n("New Window For"));
  setButtons(Ok|Cancel);
  setDefaultButton(Ok);
  setModal(true);
  showButtonSeparator(true);
  KHBox * w = new KHBox(this);
  setMainWidget(w);

  QLabel * l = new QLabel(i18n("C&hannel/Nick:"), w);

  m_combo = new KHistoryCombo(w);
  m_combo->setFocus();

  // we don't need duplicated channel into the list
  m_combo->setDuplicatesEnabled( false );

  l->setBuddy(m_combo);

  QLabel * l2 = new QLabel(i18n("&Key:"), w);
  m_le = new KLineEdit(w);
  m_le->setEnabled(false);
  l2->setBuddy(m_le);

  connect(
      m_combo, SIGNAL(activated(const QString &)),
      m_combo, SLOT(addToHistory(const QString &)));
  connect( m_combo->lineEdit(), SIGNAL(textChanged ( const QString & )),
	   this, SLOT( slotTextChanged( const QString &)));

  KConfig *kConfig = KGlobal::config();
  KConfigGroup group(kConfig, "Recent");
  m_combo->setHistoryItems(group.readEntry("Channels",QStringList()));
  slotTextChanged( m_combo->lineEdit()->text());
}

NewWindowDialog::~NewWindowDialog()
{
  KConfig *kConfig = KGlobal::config();
  KConfigGroup group(kConfig, "Recent");
  group.writeEntry("Channels", m_combo->historyItems());
}

void NewWindowDialog::slotTextChanged( const QString &text)
{
  enableButtonOk( !text.isEmpty() );

  if(text[0] == QLatin1Char('#') || text[0] == QLatin1Char('&'))
    m_le->setEnabled(true);
  else
    m_le->setEnabled(false);
}


  void
NewWindowDialog::slotOk()
{
  m_channelInfo.setChannel(m_combo->lineEdit()->text().lower());
  if(m_le->isEnabled())
    m_channelInfo.setKey(m_le->text());
  emit(openTopLevel(m_channelInfo));
  KDialog::accept();
}

#include "NewWindowDialog.moc"

