#ifndef IOCONTROL_H
#define IOCONTROL_H

#include <qobject.h>
//Added by qt3to4:
#include <QByteArray>

class KProcess;
class KSircProcess;
class Q3ListBox;
class Q3ListBoxItem;
class QPoint;

class KSircIOController : public QObject
{

  Q_OBJECT
  friend class KSircProcess;
public:
  KSircIOController(KProcess *, KSircProcess *);
  virtual ~KSircIOController();

  void showDebugTraffic(bool show);
  bool isDebugTraffic();

public slots:
  virtual void stdout_read(KProcess *proc, char *_buffer, int buflen);
  virtual void stderr_read(KProcess *proc, char *_buffer, int buflen);

  virtual void stdin_write(QByteArray);

  virtual void sircDied(KProcess *);

  virtual void appendDebug(QString);


protected slots:
  virtual void procCTS(KProcess *);

private slots:
  void showContextMenuOnDebugWindow( Q3ListBoxItem *, const QPoint &pos );

private:
  QByteArray holder;
  bool proc_CTS;
  KProcess *proc;
  KSircProcess *ksircproc;
  char *send_buf;

  QByteArray buffer;

  static int counter;

  Q3ListBox *m_debugLB;
};

#endif
